$('.stat').bind('input', function () {
    var inputName = $(this).attr('name');
    var mod = parseInt($(this).val()) - 10;

    if (mod % 2 == 0)
        mod = mod / 2;
    else
        mod = (mod - 1) / 2;

    if (isNaN(mod))
        mod = "";
    else if (mod >= 0)
        mod = "+" + mod;

    var scoreName = inputName.slice(0, inputName.indexOf("score"));
    var modName = scoreName + "mod";

    $("[name='" + modName + "']").val(mod);
});

$('.statmod').bind('change', function () {
    var name = $(this).attr('name');
    name = "uses" + name.slice(0, name.indexOf('mod'));

});

$("[name='classlevel']").bind('input', function () {
    var classes = $(this).val();
    var r = new RegExp(/\d+/g);
    var total = 0;
    var result;
    while ((result = r.exec(classes)) != null) {
        var lvl = parseInt(result);
        if (!isNaN(lvl))
            total += lvl;
    }
    var prof = 2;
    if (total > 0) {
        total -= 1;
        prof += Math.trunc(total / 4);
        prof = "+" + prof;
    } else {
        prof = "";
    }
    $("[name='proficiencybonus']").val(prof);
});

$("[name='totalhd']").bind('input', function () {
    $("[name='remaininghd']").val($(this).val());
});

// set name
$("[name='charname']").bind('input', function () {
    window.template.setName($(this).val());
});

$(document).ready(refreshData());

function reload() {
    location.reload();
}

function refreshData() {
    // name
    var name = $('.charname input');
    
    name.val(window.template.getName());

    // stats
    var str = $("[name='Strengthscore']");
    var dex = $("[name='Dexterityscore']");
    var con = $("[name='Constitutionscore']");
    var int = $("[name='Intelligencescore']");
    var wis = $("[name='Wisdomscore']");
    var cha = $("[name='Charismascore']");

    str.val(window.template.getAbilityScore(0));
    calculateStatMod(str);
    dex.val(window.template.getAbilityScore(1));
    calculateStatMod(dex);
    con.val(window.template.getAbilityScore(2));
    calculateStatMod(con);
    int.val(window.template.getAbilityScore(3));
    calculateStatMod(int);
    wis.val(window.template.getAbilityScore(4));
    calculateStatMod(wis);
    cha.val(window.template.getAbilityScore(5));
    calculateStatMod(cha);

    // class and race
    var classlevel = $('.misc #classlevel');
    var race = $('.misc #race');
    var classes = window.template.getClasses().accessClasses().toArray();

    var creatureClass;

    // NOTE: this only works for single class characters at the moment.
    for(i = 0; i < classes.length(); i++)
    {
        if (undefined === classes[i]) continue;

        var value = classes[i];
        if (value.getLevel() > 0)
        { 
            creatureClass = value;
            var entry = value.getName() + " " + value.getLevel();
            classlevel.val(entry);
            calculateProficienceMod(entry);
        } else {
            race.val(value.getName());
        }
    }

    // hit points
    var maxhp = $("[name='maxhp']");
    var currenthp = $("[name='currenthp']");
    var temphp = $("[name='temphp']");

    maxhp.val(window.template.getHPMax());
    currenthp.val(window.template.getHP());
    temphp.val(window.template.getHPTemp());

    // hit dice
    var hitdice = $("[name='totalhd']");
    var remainingdice = $("[name='remaininghd']");
    // Build total hit dice:
    var dietype = creatureClass.accessClassTemplate().accessHitDie();
    var level = creatureClass.getLevel();
    hitdice.val(level + dietype);
    
    // calculate remaining hd in rest pool
    try {
        var shortresttrait = window.template.getTraitByName("Short Rest (" + dietype + ")");
        remainingdice.val(shortresttrait.getPools().get(0).getRemainingCharges() + dietype);
    } catch(err) {

    }

    // saving throws and proficiencies
    var strprof = $("[name='Strength-save-prof']");
    var dexprof = $("[name='Dexterity-save-prof']");
    var conprof = $("[name='Constitution-save-prof']");
    var intprof = $("[name='Intelligence-save-prof']");
    var wisprof = $("[name='Wisdom-save-prof']");
    var chaprof = $("[name='Charisma-save-prof']");

    var saves = creatureClass.accessClassTemplate().accessSavingThrows();
    for(i = 0; i < saves.length(); i++)
    {
        if (saves[i] == "Str") strprof.prop('checked', true);
        if (saves[i] == "Dex") dexprof.prop('checked', true);
        if (saves[i] == "Con") conprof.prop('checked', true);
        if (saves[i] == "Int") intprof.prop('checked', true);
        if (saves[i] == "Wis") wisprof.prop('checked', true);
        if (saves[i] == "Cha") chaprof.prop('checked', true);
    }

    var strsave = $("[name='Strength-save']");
    var dexsave = $("[name='Dexterity-save']");
    var consave = $("[name='Constitution-save']");
    var intsave = $("[name='Intelligence-save']");
    var wissave = $("[name='Wisdom-save']");
    var chasave = $("[name='Charisma-save']");

    for(i = 0; i < 6; i++)
    {
        var save;
        if (creatureClass.getCreature().getSave(i) !== undefined)
            save = creatureClass.getCreature().getSave(i);
        else 
            save = 0;

        var prof = true;

        switch(i) {
            case 0:
                strsave.val(save);
                // strprof.val(prof);
               break;
            case 1:
                dexsave.val(save);
                // dexprof.val(prof);
                break;
            case 2:
                consave.val(save);
                // conprof.val(prof);
                break;
            case 3:
                intsave.val(save);
                // intprof.val(prof);
                break;
            case 4:
                wissave.val(save);
                // wisprof.val(prof);
                break;
            case 5:
                chasave.val(save);
                // conprof.val(prof);  
                break;
        }
    }

    // Armor class
    var armorclass = $("[name='ac']");
    var maxdex = window.template.getMaxDexBonus();
    var totalac = 10;

    // From the old sheet, the 5e AC map is as follows:
    // ac 0 is Natural Armor bonus
    // ac 1 is Armored Armor bonus
    // ac 2 is Shield bonus
    // ac 3 is Magic bonus
    // ac 4 is Unnamed bonus
    // ac 5 is Dodge bonus
    for(i = 0; i < 6; i++) {
        var ac = window.template.accessACWithMod(i);
        if (i < 2 && ac > 0)
            totalac = ac;
        else 
            totalac += ac;
    }

    // add in dex bonus if applicable
    // window.alert(maxdex);
    var dexmod = 0;
    dexmod = parseInt($("[name='Dexteritymod']").val());
    if (maxdex < 0)
        totalac += dexmod;
    else 
        totalac += Math.max(dexmod - maxdex, 0);

    // if we were using size...
    // window.template.getSize()  would return the size type and need to be mapped to a modifier.

    armorclass.val(totalac); // get the first AC type, usually armor.

    // Traits & Features
    var features = $("[name='features']");
    var traits = window.template.getTraits().values().toArray();
    var tlist = [];
    // create feature entries from traits
    for(i = 0; i < traits.length(); i++) {
        tlist[i] = "[lvl-" + traits[i].getLevel() + "] " + traits[i].getName();
    }
    tlist.sort();

    var traitslist = "";
    for(i = 0; i < tlist.length; i++) {
        if (i > 0)
            traitslist += "\n";

        traitslist += tlist[i];
    }
    // push to features area
    features.val(traitslist);

    // Skills
    var skills = {
        "Acrobatics" : $("[name='Acrobatics']"),
        "Animal Handling" : $("[name='Animal Handling']"),
        "Arcana" : $("[name='Arcana']"),
        "Athletics" : $("[name='Athletics']"),
        "Deception" : $("[name='Deception']"),
        "History" : $("[name='History']"),
        "Insight" : $("[name='Insight']"),
        "Intimidation" : $("[name='Intimidation']"),
        "Investigation" : $("[name='Investigation']"),
        "Medicine" : $("[name='Medicine']"),
        "Nature" : $("[name='Nature']"),
        "Perception" : $("[name='Perception']"),
        "Performance" : $("[name='Performance']"),
        "Persuasion" : $("[name='Persuasion']"),
        "Religion" : $("[name='Religion']"),
        "Sleight of Hand" : $("[name='Slieight of Hand']"),
        "Stealth" : $("[name='Stealth']"),
        "Survival" : $("[name='Survival']")
    }; 
    
    var skillsprof = {
        "Acrobatics" : $("[name='Acrobatics-prof']"),
        "Animal Handling" : $("[name='Animal Handling-prof']"),
        "Arcana" : $("[name='Arcana-prof']"),
        "Athletics" : $("[name='Athletics-prof']"),
        "Deception" : $("[name='Deception-prof']"),
        "History" : $("[name='History-prof']"),
        "Insight" : $("[name='Insight-prof']"),
        "Intimidation" : $("[name='Intimidation-prof']"),
        "Investigation" : $("[name='Investigation-prof']"),
        "Medicine" : $("[name='Medicine-prof']"),
        "Nature" : $("[name='Nature-prof']"),
        "Perception" : $("[name='Perception-prof']"),
        "Performance" : $("[name='Performance-prof']"),
        "Persuasion" : $("[name='Persuasion-prof']"),
        "Religion" : $("[name='Religion-prof']"),
        "Sleight of Hand" : $("[name='Slieight of Hand-prof']"),
        "Stealth" : $("[name='Stealth-prof']"),
        "Survival" : $("[name='Survival-prof']")
    }; 

    var cskills = window.template.getSkills().getSkills();
    var profbonus = $("[name='proficiencybonus']").val();

    var passiveperception = 10;
    
    for(i = 0; i < cskills.length(); i++) {
        var key = cskills[i].getName();
        if (skills[key] != undefined) {
            skills[key].val(cskills[i].getRanks() * profbonus);
            if(cskills[i].getRanks() > 0)
                skillsprof[key].prop('checked', true);    
        } else {
            // configure additional proficience lines
            var bonus = cskills[i].getRanks() * profbonus;
            if (bonus > 0) 
                bonus = "+" + bonus;
            else if (bonus < 0)
                bonus = "-" + bonus; 
                
            var other = cskills[i].getName() + " [ " + bonus + " ]";

            // add this skill to the other prof and languages section
            var otherprofs = $("[name='otherprofs']");
            if (otherprofs.val() != "")
            {
                otherprofs.val(otherprofs.val() + "\n" + other);
            } else {
                otherprofs.val(other);
            }

        }

        if(key == "Perception") 
            passiveperception += parseInt(skills[key].val());
    }

    if (passiveperception != 10) {
        $("[name='passiveperception']").val(passiveperception);
    } else {
        var wismod = parseInt($("[name='Wisdommod']").val());
        $("[name='passiveperception']").val(10 + wismod);
    }

    // Equipment
    var items = window.template.getItems().accessItems().toArray();
    var equipment = $("[name='Equipment']");

    var equipmentlist = "";
    for(i = 0; i < items.length(); i++) {
        if (i > 0)
            equipmentlist += "\n";

        equipmentlist += items[i].getName();

        if (items[i].accessQuantity() > 1)
            equipmentlist += "(" + items[i].accessQuantity() + ")";
    }

    equipment.val(equipmentlist);

    // Attacks
    var attacks = window.template.getAttacks().toArray();
    var attackname = $("[name='']");
    
    for(i = 0; i < attacks.length(); i++) {
        if (i < 3) {
            $("[name='atkname" + i + "']").val(attacks[i].getName());
            $("[name='atkdamage" + i + "']").val(attacks[i].getDamages().toString());

            var tohit = parseInt(attacks[i].getAbilityToHit()) + parseInt(profbonus);
            var todmg = parseInt(window.template.accessAbilityScoreMod(attacks[i].getAbilityToDamage()));

            $("[name='atkbonus" + i + "']").val( tohit + " / " + todmg);
        }
    }

    // submit form to refresh calculated values
    //$(".charsheet").sumbit();
}

function calculateProficienceMod(cls) {
    var classes = cls;
    var r = new RegExp(/\d+/g);
    var total = 0;
    var result;
    while ((result = r.exec(classes)) != null) {
        var lvl = parseInt(result);
        if (!isNaN(lvl))
            total += lvl;
    }
    var prof = 2;
    if (total > 0) {
        total -= 1;
        prof += Math.trunc(total / 4);
        prof = "+" + prof;
    } else {
        prof = "";
    }
    $("[name='proficiencybonus']").val(prof);
}

function calculateStatMod(stat) {
    var inputName = stat.attr('name');
    var mod = parseInt(stat.val()) - 10;

    if (mod % 2 == 0)
        mod = mod / 2;
    else
        mod = (mod - 1) / 2;

    if (isNaN(mod))
        mod = "";
    else if (mod >= 0)
        mod = "+" + mod;

    var scoreName = inputName.slice(0, inputName.indexOf("score"));
    var modName = scoreName + "mod";

    $("[name='" + modName + "']").val(mod);
}

function totalhd_clicked() {
    $("[name='remaininghd']").val($("[name='totalhd']").val());
}